<template>
  <v-app>
    <div class="app">
      <WLanguages />

      <WForm
        ref="WForm"
        :empty-city="isEmptyCity"
        :available-city="isAvailableCity"
        @submit="submitForm"
        @clear-errors="onClearErrors"
      />

      <div class="cards">
        <WCard
          v-for="item in weatherItems"
          :key="item.id"
          :item="item"
          @delete="onDeleteCard"
          @click="onClickCard(item.name)"
        />
      </div>
    </div>
  </v-app>
</template>

<script>
import axios from "axios";

import WLanguages from "@/components/WLanguages";
import WForm from "@/components/WForm";
const WCard = () => import("@/components/WCard");

const API_KEY = "84e2a9ad0b2bca1922b23252454cc8a2";

export default {
  name: "App",
  components: {
    WLanguages,
    WForm,
    WCard,
  },
  data() {
    return {
      isEmptyCity: false,
      isAvailableCity: false,
      weatherItems: [],
    };
  },
  created() {
    this.getWeatherItemsFromStorage();
  },
  methods: {
    async submitForm({ query }) {
      try {
        const { locale } = this.$i18n;
        const endpoint = `https://api.openweathermap.org/data/2.5/weather?q=${query}&appid=${API_KEY}&lang=${locale}&units=metric`;

        const { data } = await axios.get(endpoint);

        this.isAvailableCity = this.weatherItems.some(
          (item) => item.id === data.id
        );

        if (this.isAvailableCity) {
          throw new Error("Такой город уже добавлен");
        }

        const items = [{ ...data }, ...this.weatherItems];
        this.setWeatherItems(items);

        this.$refs.WForm.resetForm();
      } catch (error) {
        this.isEmptyCity = error.response?.data?.cod === "404";
        this.$refs.WForm.validate();
        console.error(error);
      }
    },

    getWeatherItemsFromStorage() {
      if (!localStorage.getItem("weatherItems")) {
        return;
      }

      try {
        const weatherItems = localStorage.getItem("weatherItems");
        this.weatherItems = JSON.parse(weatherItems);
      } catch (error) {
        console.error(error);
      }
    },

    onClearErrors() {
      this.isEmptyCity = false;
      this.isAvailableCity = false;
    },

    setWeatherItems(items) {
      try {
        this.weatherItems = items;
        localStorage.setItem("weatherItems", JSON.stringify(this.weatherItems));
      } catch (error) {
        console.error(error);
      }
    },

    onDeleteCard(id) {
      const items = this.weatherItems.filter((item) => item.id !== id);
      this.setWeatherItems(items);
    },

    onClickCard(name) {
      this.$refs.WForm.fillFormField(name);
    },
  },
};
</script>

<style lang="scss">
.app {
  display: flex;
  flex-direction: column;
  justify-content: flex-start;
  min-height: 100vh;
  min-width: 100vw;
  padding: 25vh 0 0 0;
}

.cards {
  display: flex;
  align-items: flex-start;
  flex-wrap: wrap;
  padding: 0 24px;
  margin: 48px -24px 0 -24px;
  width: 100%;
}
</style>
